/* ***** BEGIN LICENSE BLOCK *****
 * This file has been taken from the Thunderbird 2.0 source, and modified
 * by Jelte Jansen, original license below.
 *
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Scott MacGregor <mscott@mozilla.org>
 *   Jens Bannmann <jens.b@web.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


MailboxAlertNewMail.prefillAlertInfo = function ()
{
	var subject = window.arguments[0];
	var message = window.arguments[1];
	var show_icon = window.arguments[2];
	var image_url = window.arguments[3];
    MailboxAlertNewMail.folder = window.arguments[4];
    MailboxAlertNewMail.message_hdr = window.arguments[5];
	window.class = "MyClass";

	var label = document.getElementById('subject');
	label.value = subject;

	// let's do some playing with the message field
    // we'll 'wrap' to 50 characters
	if (message.length > 0) {
		var wrapsize = 50;
		if (subject.length > wrapsize) {
			wrapsize = subject.length;
		}
		var cur_index = 0;
        var totalLength = 0;
		var lines = new Array();
		while (message.length > wrapsize) {
			// find the last space character, if there is none, break hard at current pos
            var pos;
			var enterpos = message.indexOf("\n");
			var spacepos = message.lastIndexOf(" ", wrapsize);
			var space = false;
			if (enterpos >= 0 && enterpos < wrapsize) {
				pos = enterpos;
				space = true;
			} else if (spacepos > 0) {
				pos = spacepos;
				space = true;
			} else {
				pos = wrapsize;
			}
			var stringpart = message.substring(0, pos);
			totalLength = message.length;
			if (space) {
				message = message.substring(pos + 1, totalLength);
			} else {
				message = message.substring(pos, totalLength);
			}
			lines[cur_index] = stringpart;
			cur_index++;
		}

		var enterpos = message.indexOf("\n");
		while (enterpos >= 0 && enterpos < message.length) {
			pos = enterpos;
			var stringpart = message.substring(0, pos);
			totalLength = message.length;
			message = message.substring(pos + 1, totalLength);
			lines[cur_index] = stringpart;
			cur_index++;
			enterpos = message.indexOf("\n");
		}

		lines[cur_index] = message;
		if (lines.length > 1) {
			for (cur_index = 1; cur_index < lines.length && cur_index < 5; cur_index++) {
				var label = document.getElementById('message_field'+cur_index);
				label.value = lines[cur_index];
				label.hidden = false;
			}
		}

		var label = document.getElementById('message_field');
		label.value = lines[0];
		//label.cols = max;
		//alert(label.width);

		label.hidden = false;

		var container = document.getElementById('alertMessageField');
		container.hidden = false;
	}
	var image = document.getElementById('alertImage');
	if (show_icon) {
		image.src = image_url;
	} else {
		image.hidden = true;
	}
}

MailboxAlertNewMail.onAlertLoad = function ()
{
  // read out our initial settings from prefs.
  try 
  {
    var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
  } catch (ex) { }
  try 
  {
    MailboxAlertNewMail.position = prefBranch.getCharPref("extensions.mailboxalert.alert_position");
  } catch (ex) { }
  try 
  {
    MailboxAlertNewMail.duration = prefBranch.getIntPref("extensions.mailboxalert.alert_duration");
  } catch (ex) { }
  try 
  {
    MailboxAlertNewMail.effect = prefBranch.getCharPref("extensions.mailboxalert.alert_effect");
  } catch (ex) { }
  try 
  {
    MailboxAlertNewMail.onclick = prefBranch.getCharPref("extensions.mailboxalert.alert_onclick");
  } catch (ex) { }
  
  // bogus call to make sure the window is moved offscreen until we are ready for it.
  MailboxAlertNewMail.resizeAlert(true);

  // if we aren't waiting to fetch preview text, then go ahead and 
  // start showing the alert.
  if (MailboxAlertNewMail.effect == "fade") {
    setTimeout(MailboxAlertNewMail.showAlertFade, 0); // let the JS thread unwind, to give layout 
                              // a chance to recompute the styles and widths for our alert text.
  } else if (MailboxAlertNewMail.effect == "slide") {
    setTimeout(MailboxAlertNewMail.showAlertSlide, 0);
  } else {
    MailboxAlertNewMail.resizeAlert(false);
    MailboxAlertNewMail.placeAlert();
    setTimeout(MailboxAlertNewMail.closeAlert, MailboxAlertNewMail.duration * 1000);
  }
}

MailboxAlertNewMail.showAlertSlide = function ()
{
  var top = true;

  var alertContainer = document.getElementById('alertContainer');
  alertContainer.style.opacity = 0;
  MailboxAlertNewMail.resizeAlert(false);
  MailboxAlertNewMail.placeAlert();

  MailboxAlertNewMail.window_y = -MailboxAlertNewMail.getWindowHeight();
  
  if (MailboxAlertNewMail.position == "tr") {
    MailboxAlertNewMail.window_x = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.LEFT ? screen.availLeft :
        (screen.availLeft + screen.availWidth - MailboxAlertNewMail.getWindowWidth());
  } else if (MailboxAlertNewMail.position == "br") {
    top = false;
    MailboxAlertNewMail.window_x = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.LEFT ? screen.availLeft :
        (screen.availLeft + screen.availWidth - MailboxAlertNewMail.getWindowWidth());
    MailboxAlertNewMail.window_y = screen.height + MailboxAlertNewMail.getWindowHeight();
    MailboxAlertNewMail.window_to_y = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.TOP ? screen.availTop :
        (screen.availTop + screen.availHeight - MailboxAlertNewMail.getWindowHeight());
  } else if (MailboxAlertNewMail.position == "bl") {
    top = false;
    MailboxAlertNewMail.window_y = screen.height + MailboxAlertNewMail.getWindowHeight();
    MailboxAlertNewMail.window_to_y = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.TOP ? screen.availTop :
        (screen.availTop + screen.availHeight - MailboxAlertNewMail.getWindowHeight());
  } else if (MailboxAlertNewMail.position == "c") {
    MailboxAlertNewMail.window_x = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.LEFT ? screen.availLeft :
        ((screen.availLeft + screen.availWidth) / 2 - (MailboxAlertNewMail.getWindowWidth() / 2));
    MailboxAlertNewMail.window_y = -MailboxAlertNewMail.getWindowHeight();
    MailboxAlertNewMail.window_to_y = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.TOP ? screen.availTop :
        ((screen.availTop + screen.availHeight) / 2 - (MailboxAlertNewMail.getWindowHeight() / 2));
  }
  //window.sizeToContent();
  //window.resizeTo(MailboxAlertNewMail.getWindowWidth(), MailboxAlertNewMail.getWindowHeight());
  window.moveTo(MailboxAlertNewMail.window_x, MailboxAlertNewMail.window_y);
  MailboxAlertNewMail.resizeAlert(false);
  MailboxAlertNewMail.placeAlertOutside();
  alertContainer.style.opacity = 1;

  if (top) {
    setTimeout(MailboxAlertNewMail.slideInTop, MailboxAlertNewMail.gSlideTime);
  } else {
    setTimeout(MailboxAlertNewMail.slideInBottom, MailboxAlertNewMail.gSlideTime);
  }
}

MailboxAlertNewMail.slideInTop = function ()
{
  if (window.screenY < MailboxAlertNewMail.window_to_y) {
    window.moveBy(0, MailboxAlertNewMail.gSlideDistance);
    setTimeout(MailboxAlertNewMail.slideInTop, MailboxAlertNewMail.gSlideTime);
  } else {
    MailboxAlertNewMail.window_to_y = -MailboxAlertNewMail.getWindowHeight();
    setTimeout(MailboxAlertNewMail.slideOutTop, MailboxAlertNewMail.duration * 1000);
  }
}

MailboxAlertNewMail.slideOutTop = function ()
{
  if (window.screenY > MailboxAlertNewMail.window_to_y) {
  	window.moveBy(0, -MailboxAlertNewMail.gSlideDistance);
  	setTimeout(MailboxAlertNewMail.slideOutTop, MailboxAlertNewMail.gSlideTime);
  } else {
  	window.close();
  }
}

MailboxAlertNewMail.slideInBottom = function ()
{
  MailboxAlertNewMail.window_y = MailboxAlertNewMail.window_y - MailboxAlertNewMail.gSlideDistance;
  if (MailboxAlertNewMail.window_y > MailboxAlertNewMail.window_to_y) {
  	window.moveTo(MailboxAlertNewMail.window_x, MailboxAlertNewMail.window_y);
  	setTimeout(MailboxAlertNewMail.slideInBottom, MailboxAlertNewMail.gSlideTime);
  } else {
  	window.moveTo(MailboxAlertNewMail.window_x, MailboxAlertNewMail.window_to_y);
  	MailboxAlertNewMail.window_y = MailboxAlertNewMail.window_to_y;
  	MailboxAlertNewMail.window_to_y = screen.height + MailboxAlertNewMail.getWindowHeight();
  	setTimeout(MailboxAlertNewMail.slideOutBottom, MailboxAlertNewMail.duration * 1000);
  }
}

MailboxAlertNewMail.slideOutBottom = function ()
{
  MailboxAlertNewMail.window_y = MailboxAlertNewMail.window_y + MailboxAlertNewMail.gSlideDistance;
  if (MailboxAlertNewMail.window_y < MailboxAlertNewMail.window_to_y) {
  	window.moveTo(MailboxAlertNewMail.window_x, MailboxAlertNewMail.window_y);
  	setTimeout(MailboxAlertNewMail.slideOutBottom, MailboxAlertNewMail.gSlideTime);
  } else {
  	window.close();
  }
}

MailboxAlertNewMail.showAlertFade = function ()
{
	var alertContainer = document.getElementById('alertContainer');
	alertContainer.style.opacity = 0;
	MailboxAlertNewMail.resizeAlert(false);
        MailboxAlertNewMail.placeAlert();
	setTimeout(MailboxAlertNewMail.fadeOpen, MailboxAlertNewMail.gFadeTime);
}

MailboxAlertNewMail.getWindowHeight = function ()
{
  return 10 + Math.max (document.getBoxObjectFor(document.getElementById('alertTextBox')).height
                  ,document.getBoxObjectFor(document.getElementById('alertImage')).height);
}

MailboxAlertNewMail.getWindowWidth = function ()
{
  return 30
         + document.getBoxObjectFor(document.getElementById('alertImage')).width
         + Math.max (document.getBoxObjectFor(document.getElementById('subject')).width,
                     document.getBoxObjectFor(document.getElementById('message_field')).width);
}

MailboxAlertNewMail.resizeAlert = function (aMoveOffScreen)
{
  resizeTo(MailboxAlertNewMail.getWindowWidth(), MailboxAlertNewMail.getWindowHeight());

  // leftover hack to get the window properly hidden when we first open it
  if (aMoveOffScreen) {
    window.outerHeight = 1;
  }
}

MailboxAlertNewMail.placeAlert = function () {
  var x = 0;
  var y = 0;

  if (MailboxAlertNewMail.position == "tr") {
    x = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.LEFT ? screen.availLeft :
        (screen.availLeft + screen.availWidth - MailboxAlertNewMail.getWindowWidth());
  } else if (MailboxAlertNewMail.position == "br") {
    x = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.LEFT ? screen.availLeft :
        (screen.availLeft + screen.availWidth - MailboxAlertNewMail.getWindowWidth());
    y = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.TOP ? screen.availTop :
        (screen.availTop + screen.availHeight - MailboxAlertNewMail.getWindowHeight());
  } else if (MailboxAlertNewMail.position == "bl") {
    y = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.TOP ? screen.availTop :
        (screen.availTop + screen.availHeight - MailboxAlertNewMail.getWindowHeight());
  } else if (MailboxAlertNewMail.position == "c") {
    x = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.LEFT ? screen.availLeft :
        ((screen.availLeft + screen.availWidth) / 2 - (MailboxAlertNewMail.getWindowWidth() / 2));
    y = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.TOP ? screen.availTop :
        ((screen.availTop + screen.availHeight) / 2 - (MailboxAlertNewMail.getWindowHeight() / 2));
  }
  window.moveTo(x, y);
}

MailboxAlertNewMail.placeAlertOutside = function () {
  var x = 0;
  var y = -MailboxAlertNewMail.getWindowHeight();

  if (MailboxAlertNewMail.position == "tr") {
    x = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.LEFT ? screen.availLeft :
        (screen.availLeft + screen.availWidth - MailboxAlertNewMail.getWindowWidth());
  } else if (MailboxAlertNewMail.position == "br") {
    x = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.LEFT ? screen.availLeft :
        (screen.availLeft + screen.availWidth - MailboxAlertNewMail.getWindowWidth());
    y = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.TOP ? screen.availTop :
        (screen.availTop + screen.availHeight);
  } else if (MailboxAlertNewMail.position == "bl") {
    y = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.TOP ? screen.availTop :
        (screen.availTop + screen.availHeight);
  } else if (MailboxAlertNewMail.position == "c") {
    x = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.LEFT ? screen.availLeft :
        ((screen.availLeft + screen.availWidth) / 2 - (MailboxAlertNewMail.getWindowWidth() / 2));
/*
    y = MailboxAlertNewMail.gOrigin & MailboxAlertNewMail.TOP ? screen.availTop :
        ((screen.availTop + screen.availHeight) / 2 - (MailboxAlertNewMail.getWindowHeight() / 2));
*/
  }
  window.moveTo(x, y);
}

MailboxAlertNewMail.fadeOpen = function ()
{
  var alertContainer = document.getElementById('alertContainer');
  var newOpacity = parseFloat(window.getComputedStyle(alertContainer, "").opacity) + MailboxAlertNewMail.gFadeIncrement;
  alertContainer.style.opacity = newOpacity;
  
  if (newOpacity < 1.0)    
    setTimeout(MailboxAlertNewMail.fadeOpen, MailboxAlertNewMail.gFadeTime);
  else { // switch gears and start closing the alert
    setTimeout(MailboxAlertNewMail.fadeClose, 1000 * MailboxAlertNewMail.duration);
  }
}

MailboxAlertNewMail.fadeClose = function ()
{
  var alertContainer = document.getElementById('alertContainer');
  var newOpacity = parseFloat(window.getComputedStyle(alertContainer, "").opacity) - MailboxAlertNewMail.gFadeIncrement;
  alertContainer.style.opacity = newOpacity;
  if (newOpacity <= 0) {
    window.close();
  } else {
    setTimeout(MailboxAlertNewMail.fadeClose, MailboxAlertNewMail.gFadeTime);
  }
}

MailboxAlertNewMail.closeAlert = function ()
{
  if (MailboxAlertNewMail.effect == "fade") {
    MailboxAlertNewMail.fadeClose();
  } else if (MailboxAlertNewMail.effect == "slide") {
    if (MailboxAlertNewMail.position == "tr" || MailboxAlertNewMail.position == "tl") {
      MailboxAlertNewMail.slideOutTop();
    } else if (MailboxAlertNewMail.position == "br" || MailboxAlertNewMail.position == "bl") {
      MailboxAlertNewMail.slideOutBottom();
    } else {
      window.close();
    }
  } else {
    window.close();
  }
}

MailboxAlertNewMail.handleClick = function ()
{
    dump("Alert window clicked\n");
    if (MailboxAlertNewMail.onclick == "close") {
        dump("Close alert window\n");
        // Do nothing, the window will be closed at the end of this
        // function.
    } else if (MailboxAlertNewMail.onclick == "selectmail") {
        dump("Select mail\n");
        const Cc = Components.classes;
        const Ci = Components.interfaces;
        var windowManager = Cc['@mozilla.org/appshell/window-mediator;1'].getService();
        var windowManagerInterface = windowManager.QueryInterface(Ci.nsIWindowMediator);
        //var windowManagerInterface = windowManager.QueryInterface(Ci.nsIWindowMediator);
        
        var mailWindow = windowManagerInterface.getMostRecentWindow( "mail:3pane" );
        if ( mailWindow ) {
            tabmail = mailWindow.document.getElementById("tabmail");
            tabmail.selectTabByMode('folder');
            if (MailboxAlertNewMail.message_hdr) {
                mailWindow.gFolderTreeView.selectFolder(MailboxAlertNewMail.folder);
                mailWindow.gDBView.selectMsgByKey(MailboxAlertNewMail.message_hdr.messageKey);
            }
            mailWindow.restore();
            mailWindow.focus();
        } else {
            dump("did not get mailWindow\n");
            window.open(uri, "_blank", "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar");
        }
    } else if (MailboxAlertNewMail.onclick == "openmail") {
        // get the messenger window open service and ask it to open a new window for us
        var mailWindowService = Components.classes["@mozilla.org/messenger/windowservice;1"].getService(Components.interfaces.nsIMessengerWindowService);
        if (mailWindowService) {
            window.openDialog( "chrome://messenger/content/messageWindow.xul", "_blank", "all,chrome,dialog=no,status,toolbar", MailboxAlertNewMail.message_hdr, null );
        } else {
            dump("Could not get nsIMsgWindow service\n");
        }
    }
    MailboxAlertNewMail.closeAlert();
}
